local M = {}

M.axisMinThreshold_move = 0.2
M.axisMinThreshold_shoot = 0.5

M.maxDistanceToInfiltrateDeadBody = 30
M.maxDistanceToEnterArmor = 30
M.maxDistanceToBondWithOtherZombie = 80

-- Soldier bodies
M.timeBeforeRotten_sec = 8

M.maxZombieOxygen = 300
M.maxOxygen = 100
M.maxArmorHP = 100
M.maxDemonHP = 1000
M.maxAvatarHP = 5
M.maxEnemyHP = {
	soldier = 20,
	tank = 150,
	chopper = 50,
}

M.yellowHPThreshold = 59
M.redHPThreshold = 39

M.weapons = {
	"machinegun", "rocket",

}

M.weaponDamageType = {
	machinegun = "kinetic",
	rocket = "explosive"
}

M.weaponDamageAmount = {
	machinegun = 5,
	rocket = 50
}

M.playerSpeed = {
	naked = 9,
	armor = 5,
	demon = 7,
	zombie = 1, -- 2 ?
	dead = 0
}

M.countDownBeforeArmorExplosion_sec = 1

M.cooldown_sec = {
	machinegun = 0.09,
	rocket = 1,
}

M.distanceOfBulletFromBodyWhenShooting = {
	naked = 8,
	armor = 12,
	demon = 32,	
}

M.freezeDelayAfterHopInArmor_sec = .5
M.freezeDelayAfterInfiltrateDeadBody_sec = .1

M.oxygenPercentLostPerSecond = 12 -- 50 for debug
M.zombieOxygenPercentLostPerSecond = 5

M.bondPercentCompletionPerSecond = 90 -- debug -- 10

-- number of pixels per second for layers whose scrolling speed factor is 1
M.referenceScrollSpeed = 50

M.maxPlayerDistanceX = W * .8

M.screenMarginX, M.screenMarginY = 0, 0

M.xThresholdToScrollCamera = W*.5

M.cameraIncrementX = 10

return M