
local GamepadButtons = {
	"a", "b", "x", "y", "back", "guide", "start", "leftstick", "rightstick", "leftshoulder", "rightshoulder", "dpup", "dpdown", "dpleft", "dpright"
}

local GamepadAxis = {
	"leftx", "lefty", "rightx", "righty", "triggerleft", "triggerright"
}

function debugJoysticks()

	local xOffset, columnW = 40, 360
	local yOffsetInit, lineH = 40, 20


	love.graphics.print("Joystick Tester", 20, 20)

	local joysticks = love.joystick.getJoysticks()
	for i, joystick in ipairs(joysticks) do

		local yOffset = yOffsetInit

		love.graphics.print( joystick:getName(), xOffset, yOffset); yOffset = yOffset + lineH
		love.graphics.print( "   "..joystick:getButtonCount().." buttons", xOffset, yOffset); yOffset = yOffset + lineH

		for k,button in ipairs(GamepadButtons) do
			if joystick:isGamepadDown(button) then
				love.graphics.setColor( 255, 0, 0, 255 )
			end
			love.graphics.print( "   Button "..button, xOffset, yOffset); yOffset = yOffset + lineH
			love.graphics.setColor( 255, 255, 255, 255 )
		end
		
		for k,axis in ipairs(GamepadAxis) do
			local value = joystick:getGamepadAxis(axis)
			if value ~= 0 then
				love.graphics.setColor( 255, 0, 0, 255 )
			end
			love.graphics.print( "   Axis "..axis.." "..value, xOffset, yOffset); yOffset = yOffset + lineH
			love.graphics.setColor( 255, 255, 255, 255 )
		end

		xOffset = xOffset + columnW 

	end

	-- -- joystick 0
	-- love.graphics.print(love.joystick.getName(0).." - joystick 0", 10, 30)

	-- if love.joystick.isOpen(0) then
	--   love.graphics.print("status: is open", 10, 50)
	-- else
	--   love.graphics.print("status: is closed", 10, 50)
	-- end

	-- love.graphics.print("number of buttons: " .. love.joystick.getNumButtons(0), 10, 70)

	-- -- check for d-pad input
	-- love.graphics.print("d-pad", 10, 110)

	-- love.graphics.print("axis: 0 value: "..love.joystick.getAxis(0, 0), 10, 130)

	-- love.graphics.print("axis: 1 value: "..love.joystick.getAxis( 0, 1 ), 10, 150)

end


function debugDisplayObjects()
	for k,vobj in ipairs(gfx.displayObjects) do
		print( vobj )
	end
end

