local min, max = math.min, math.max

local M = {}

function M.onButton_ExitVehicle( playerID )
	
end

function M.onButton_Shoot( playerID )

end

-------------------------------------------------------------------------------------------------

M.alienIterator = 0
M.armorIterator = 0
M.demonIterator = 0

-- we assume bond completion has been previously checked
function M.spawnDemon( player )
	if not player.bondingWith then return end

	local player2 = players[player.bondingWith]

	-- Setting who drives and who shoots
	local leader = players[player.bondLeader]
	local nonLeader = players[leader.bondingWith]
	leader.driving = true
	leader.shooting = false
	nonLeader.driving = false
	nonLeader.shooting = true

	-- destroying bodies
	player.avatar.vehicle.bonding = false
	player2.avatar.vehicle.bonding = false
	player.avatar.vehicle.visible = false
	player2.avatar.vehicle.visible = false
	player.avatar.vehicle.trash = true
	player2.avatar.vehicle.trash = true

	player.status = "demon"
	player2.status = "demon"

	local x = player.avatar.logic_x + (player2.avatar.logic_x - player.avatar.logic_x)*.5
	local y = player.avatar.logic_y + (player2.avatar.logic_y - player.avatar.logic_y)*.5

	local logic_dx = gfx.sizes.demon.hx
	local logic_dy = gfx.sizes.demon.hy

	x, y = x - logic_dx, y - logic_dy

	-- players[player.bondLeader].bondCompletion = nil

	M.demonIterator = M.demonIterator + 1
	local dispObjId = "demon_" .. M.demonIterator
	local o = gfx.addPicture( dispObjId, "hero", "_coderart_demon.png", x, y )
	o.id = dispObjId

	player.avatar.visible = false
	player2.avatar.visible = false

	player.avatar.vehicle = o
	player2.avatar.vehicle = o

	-- o.callbackOnHit = function( hitter )
	-- 	if o.destroyed then
	-- 		return false
	-- 	end
	-- 	if hitter.isBullet then
	-- 		if gfx.tagged( o.id, "immune_to_bullets_from_" .. hitter.emitterID ) then
	-- 			return false
	-- 		end
	-- 		local dmg = calibrate.weaponDamageAmount[hitter.weapon]
	-- 		o.armorHP = o.armorHP - dmg
	-- 		if o.armorHP < 0 then
	-- 			o.armorHP = 0
	-- 			o.destroyed = true
	-- 			o.countDownBeforeExplosion_sec = calibrate.countDownBeforeArmorExplosion_sec
	-- 		end
	-- 		return true
	-- 	end
	-- 	return false
	-- end

	o.logic_dx = logic_dx
	o.logic_dy = logic_dy
	o.logic_x = o.x + o.logic_dx
	o.logic_y = o.y + o.logic_dy
	gfx.tagDisplayObject( dispObjId, "demon" )
	-- gfx.tagDisplayObject( dispObjId, "hit_by_machinegun" )
	-- o.empty = true
	o.armorHP = calibrate.maxDemonHP
	return o

end

-- can be called from any player involved in the bond
function M.breakBond( player )
	if not player.bondingWith then return end

	local player2 = players[player.bondingWith]

	player.avatar.vehicle.bonding = false
	player2.avatar.vehicle.bonding = false
	player.bondingWith = nil
	player2.bondingWith = nil
	players[player.bondLeader].bondCompletion = nil
	player.bondLeader = nil
	player2.bondLeader = nil

end

function M.startBond( player, player2 )
	player.avatar.vehicle.bonding = true
	player2.avatar.vehicle.bonding = true
	player.bondingWith = player2.id
	player2.bondingWith = player.id
	local dice = rand( 0, 100 )
	if dice < 50 then
		player.bondLeader = player.id
		player2.bondLeader = player.id
	else
		player.bondLeader = player2.id
		player2.bondLeader = player2.id
	end
	players[player.bondLeader].bondCompletion = 0
end

function M.exitDeadBody( player )
	if player.avatar.vehicle then
		local enemy = player.avatar.vehicle
		enemy.parasited = false
		enemy.color = false
		player.avatar.vehicle = nil
		player.avatar.x = enemy.x
		player.avatar.y = enemy.y
	end
	player.status = "naked"
	player.avatar.visible = true
	player.frozenFor_sec = nil
	-- player.avatar.oxygen = calibrate.maxOxygen
end

-- we assume it was a soldier
function M.infiltrateDeadBody( player, enemy )
	enemy.parasited = true
	enemy.bonding = false
	enemy.parasitingPlayer = player
	enemy.zombieoxygen = calibrate.maxZombieOxygen * ( 1 - enemy.rottenComplete )
	enemy.color = gfx.playerColors[player.id]
	player.status = "zombie"
	player.avatar.visible = false
	player.avatar.vehicle = enemy
	player.avatar.oxygen = calibrate.maxOxygen
	player.frozenFor_sec = calibrate.freezeDelayAfterInfiltrateDeadBody_sec
end

function M.getOffArmor( player )
	if player.avatar.vehicle then
		local armor = player.avatar.vehicle
		armor.empty = true
		armor.visible = true
		armor.color = false
		gfx.removeTagFromDisplayObject( player.avatar.vehicle.id, "immune_to_bullets_from_" .. player.id )
		player.avatar.vehicle = nil
		player.avatar.x = armor.x
		player.avatar.y = armor.y
	end
	player.status = "naked"
	player.avatar.visible = true
	player.frozenFor_sec = nil
end

function M.hopInArmor( player, armor )
	armor.empty = false
	armor.visible = true
	armor.color = gfx.playerColors[player.id]
	player.status = "armor"
	player.avatar.visible = false
	player.avatar.vehicle = armor
	gfx.tagDisplayObject( player.avatar.vehicle.id, "immune_to_bullets_from_" .. player.id )
	player.avatar.oxygen = calibrate.maxOxygen
	player.frozenFor_sec = calibrate.freezeDelayAfterHopInArmor_sec
end

function M.createArmor( x, y )
	M.armorIterator = M.armorIterator + 1
	local dispObjId = "armor_" .. M.armorIterator
	local o = gfx.addPicture( dispObjId, "hero", "_coderart_armor.png", x, y )
	o.id = dispObjId
	o.callbackOnHit = function( hitter )
		if o.destroyed then
			return false
		end
		if hitter.isBullet then
			if gfx.tagged( o.id, "immune_to_bullets_from_" .. hitter.emitterID ) then
				return false
			end
			local dmg = calibrate.weaponDamageAmount[hitter.weapon]
			o.armorHP = o.armorHP - dmg
			if o.armorHP < 0 then
				o.armorHP = 0
				o.destroyed = true
				o.countDownBeforeExplosion_sec = calibrate.countDownBeforeArmorExplosion_sec
			end
			return true
		end
		return false
	end
	o.logic_dx = gfx.sizes.armor.hx
	o.logic_dy = gfx.sizes.armor.hy
	o.logic_x = o.x + o.logic_dx
	o.logic_y = o.y + o.logic_dy
	gfx.tagDisplayObject( dispObjId, "armor" )
	gfx.tagDisplayObject( dispObjId, "hit_by_machinegun" )
	o.empty = true
	o.armorHP = calibrate.maxArmorHP
	return o
end

function M.spawnAlien( player, x, y )
	M.alienIterator = M.alienIterator + 1
	local dispObjId = "naked_" .. M.alienIterator
	local o = gfx.addPicture( dispObjId, "hero", "_coderart_naked.png", x, y )
	o.id = dispObjId
	o.callbackOnHit = function( hitter )
		local player = players[o.player]
		if player == "dead" then
			return false
		end
		if hitter.isBullet then
			if gfx.tagged( o.id, "immune_to_bullets_from_" .. hitter.emitterID ) then
				return false
			end
			local dmg = calibrate.weaponDamageAmount[hitter.weapon]
			o.avatarHP = o.avatarHP - dmg
			if o.avatarHP < 0 then
				o.avatarHP = 0
				player.status = "dead"
			end
			return true
		end
		return false
	end
	o.logic_dx = gfx.sizes.naked.hx
	o.logic_dy = gfx.sizes.naked.hy
	o.logic_x = o.x + o.logic_dx
	o.logic_y = o.y + o.logic_dy
	gfx.tagDisplayObject( dispObjId, "alien" )
	gfx.tagDisplayObject( dispObjId, "hit_by_machinegun" )
	gfx.tagDisplayObject( dispObjId, "immune_to_bullets_from_" .. player.id )
	o.player = player.id -- or player?
	o.color = gfx.playerColors[player.id]
	o.oxygen = calibrate.maxOxygen
	o.avatarHP = calibrate.maxAvatarHP
	return o
end

function M.initPlayer( number )
	local player = {}
	player.id = number
	player.status = "naked"
	local x, y = hW, number * hH / 4
	local armor = M.createArmor( x, y )
	player.avatar = M.spawnAlien( player, x, y )
	M.hopInArmor( player, armor )
	-- -- p.x = 200
	-- -- p.y = number * hH / 4
	-- -- p.status = "armor" -- armor / naked / demon
	-- -- p.oxygen = M.maxOxygen
	-- -- p.armorHP = M.maxArmorHP
	-- p.weapons = {}

	-- for kweapon,vnextWeapon in pairs(allWeapons) do
	-- 	p.weapons[kweapon] = false
	-- end

	player.currentWeapon = "machinegun"
	-- player.currentWeapon = "rocket"
	player.cooldown = {}
	for i,weap in ipairs( calibrate.weapons ) do
		player.cooldown[weap] = calibrate.cooldown_sec[weap]
	end

	-- -- p.weapons["knife"] = true
	-- p.weapons["rocket"] = true

	-- -- if needed
	-- gfx.addPicture( "hero_ship_" .. number, "hero", "_coderart_armor.png", p.x, p.y )
	-- -- gfx.addPicture( "hero_ship_" .. number, "hero", "soucoupe_200.png", p.x, p.y )
	-- -- gfx.addPicture( "hero_ship_thrusters_" .. number, "hero", "soucoupe_thrusters_200.png", p.x, p.y )

	-- gfx.tagDisplayObject( "hero_ship_" .. number, "hero_" .. number )
	-- -- gfx.tagDisplayObject( "hero_ship_" .. number, "hero_" .. number )
	-- -- gfx.tagDisplayObject( "hero_ship_thrusters_" .. number, "hero_" .. number )


	return player

end

function M.getPlayerMovingDisplayObject( player )
	if not player then return nil end
	if player.status == "armor" then
		return player.avatar.vehicle
	elseif player.status == "naked" then
		return player.avatar
	elseif player.status == "zombie" then
		return player.avatar.vehicle
	elseif player.status == "demon" then
		return player.avatar.vehicle
	else
		-- gameObjToMove = player.avatar
		return nil
	end
end

-- to not use fake player feature, pass nil
function M.getMinMaxPlayersOnX( fakePlayer )
	local minXplayer, maxXplayer = nil, nil
	for n = 1,nbPlayers do
		local p = players[n]
		if p.status ~= "dead" then
			local pdispobj = M.getPlayerMovingDisplayObject( p )
			if fakePlayer and p.id == fakePlayer.id then
				pdispobj = M.getPlayerMovingDisplayObject( fakePlayer )
			end
			if not minXplayer then
				minXplayer = p
			else
				local minXplayerDisplayObject = M.getPlayerMovingDisplayObject( minXplayer )
				if pdispobj.x < minXplayerDisplayObject.x then
					minXplayer = p
				end
			end
			if not maxXplayer then
				maxXplayer = p
			else
				local maxXplayerDisplayObject = M.getPlayerMovingDisplayObject( maxXplayer )
				if pdispobj.x > maxXplayerDisplayObject.x then
					maxXplayer = p
				end
			end
		end
	end
	return minXplayer, maxXplayer
end

-- return fixed dx, dy
function M.constrainLogicDisplayObjectPositionInScreen( displayObject, halfwidth, halfheight, dx, dy )
	
	local fakeDisplayObject = {
		x = displayObject.x,
		y = displayObject.y,
		logic_dx = displayObject.logic_dx,
		logic_dy = displayObject.logic_dy,
	}
	gfx.moveDisplayObject( fakeDisplayObject, dx, dy )
	
	local fakeDisplayObject_logic_x_screen, fakeDisplayObject_logic_y_screen = gfx.coords_worldToScreen(
		fakeDisplayObject.logic_x,
		fakeDisplayObject.logic_y,
		displayObject.layerName
	)

	if fakeDisplayObject_logic_x_screen < calibrate.screenMarginX + halfwidth and dx < 0 then
		dx = 0
	elseif fakeDisplayObject_logic_x_screen > W - calibrate.screenMarginX - halfwidth and dx > 0 then
		dx = 0
	end
	if fakeDisplayObject_logic_y_screen < calibrate.screenMarginY + halfheight and dy < 0 then
		dy = 0
	elseif fakeDisplayObject_logic_y_screen > H - calibrate.screenMarginY - halfheight and dy > 0 then
		dy = 0
	end

	return dx, dy

end

-- return fixed dx, dy
function M.constrainPlayerMovement( player, dx, dy )
	
	if player.status == "dead" then
		return 0, 0
	end

	-- we calculate if the resulting position of the player is valid according to all the other players
	local fakePlayer = {
		id = player.id,
		status = player.status,
		avatar = player.avatar,
	}
	fakePlayer.avatar.vehicle = player.avatar.vehicle
	local playerDisplayObject = M.getPlayerMovingDisplayObject( player )
	local fakePlayerMovingDisplayObject = {
		x = playerDisplayObject.x,
		y = playerDisplayObject.y,
		logic_dx = playerDisplayObject.logic_dx,
		logic_dy = playerDisplayObject.logic_dy,
	}
	gfx.moveDisplayObject( fakePlayerMovingDisplayObject, dx, dy )

	-- rule #1 : minX and maxX players cannot be separated by more than W * (1-cameraMargin) pixels
	local minXplayer, maxXplayer = M.getMinMaxPlayersOnX( fakePlayer )
	local minXplayerDisplayObject = M.getPlayerMovingDisplayObject( minXplayer )
	local maxXplayerDisplayObject = M.getPlayerMovingDisplayObject( maxXplayer )
	local xDistanceMinMax = gfx.distance( minXplayerDisplayObject.x, 0, maxXplayerDisplayObject.x, 0 )
	if xDistanceMinMax > calibrate.maxPlayerDistanceX then
		-- si le joueur le plus à gauche veut aller à droite on accepte et vice versa sinon on annule le dx
		if player.id == minXplayer.id and dx < 0 then
			return 0, dy
		end
		if player.id == maxXplayer.id and dx > 0 then
			return 0, dy
		end
	end
	
	-- rule #2 : players cannot exit the screen
	local size = gfx.sizes[player.status]
	local dx, dy = M.constrainLogicDisplayObjectPositionInScreen( playerDisplayObject, size.hx, size.hy, dx, dy )

	return dx, dy

end

function M.updatePlayer( player, dt )

	if player.frozenFor_sec then
		player.frozenFor_sec = player.frozenFor_sec - dt
		if player.frozenFor_sec < 0 then
			player.frozenFor_sec = nil
		end
	end

	if player.status == "naked" then
		player.avatar.oxygen = player.avatar.oxygen - calibrate.oxygenPercentLostPerSecond * dt
		if player.avatar.oxygen < 0 then
			player.status = "dead"
		end
	end

	-- TODO if player dead

	if player.status == "zombie" and player.bondingWith then
		local player2 = players[player.bondingWith]
		local gameObj1, gameObj2 = M.getPlayerMovingDisplayObject(player), M.getPlayerMovingDisplayObject(player2)
		local distanceBetweenPlayers = gfx.distance( gameObj1.logic_x, gameObj1.logic_y, gameObj2.logic_x, gameObj2.logic_y )
		if distanceBetweenPlayers > calibrate.maxDistanceToBondWithOtherZombie then
			M.breakBond( player )
		end
	end

end


function M.updateEnemy( enemy, dt )

	-- if player.frozenFor_sec then
	-- 	player.frozenFor_sec = player.frozenFor_sec - dt
	-- 	if player.frozenFor_sec < 0 then
	-- 		player.frozenFor_sec = nil
	-- 	end
	-- end

	-- if player.status == "naked" then
	-- 	player.avatar.oxygen = player.avatar.oxygen - calibrate.oxygenPercentLostPerSecond * dt
	-- 	if player.avatar.oxygen < 0 then
	-- 		player.status = "dead"
	-- 	end
	-- end

	if gfx.tagged( enemy.id, "soldier" ) then

		if enemy.destroyed
		and not enemy.rotten -- no need to update anymore
		and not enemy.parasited -- decay in pause
		then
			enemy.timeBeforeRotten_sec = enemy.timeBeforeRotten_sec - dt
			enemy.rottenComplete = ( calibrate.timeBeforeRotten_sec - enemy.timeBeforeRotten_sec ) / calibrate.timeBeforeRotten_sec
			if enemy.timeBeforeRotten_sec < 0 then
				enemy.rotten = true
				enemy.timeBeforeRotten_sec = 0
			end
		end

		if enemy.destroyed
		and enemy.parasited
		and not enemy.bonding
		then
			enemy.zombieoxygen = enemy.zombieoxygen - calibrate.zombieOxygenPercentLostPerSecond * dt
			if enemy.zombieoxygen < 0 then
				enemy.rotten = true
				logic.exitDeadBody( enemy.parasitingPlayer )
			end
		end

		if enemy.destroyed
		and enemy.parasited
		and enemy.bonding
		then
			local bondLeader_player = players[enemy.parasitingPlayer.bondLeader]
			bondLeader_player.bondCompletion = bondLeader_player.bondCompletion + calibrate.bondPercentCompletionPerSecond * dt
			print( "BOND COMPLETE: " .. players[enemy.parasitingPlayer.bondLeader].bondCompletion )
			if bondLeader_player.bondCompletion > 100 then
				bondLeader_player.bondCompletion = 100
				M.spawnDemon( bondLeader_player )
				-- players[enemy.parasitingPlayer.bondLeader].bondComplete = true
				-- enemy.bondingComplete = true
				-- enemy.bondingComplete = true
			end
		end

	end

end

function M.updateAllEnemies( dt )
	if gfx.objectsByTag["enemy"] then
		for k,vobjid in pairs(gfx.objectsByTag["enemy"]) do
			local displayObj = gfx.displayObjects[vobjid]
			M.updateEnemy( displayObj, dt )
		end
	end
end


function M.updateCameraPosition( dt )
	local minXplayer, maxXplayer = M.getMinMaxPlayersOnX( nil ) -- fakePlayer ) -- nil non ?
	local minXplayerDisplayObject = M.getPlayerMovingDisplayObject( minXplayer )
	local maxXplayerDisplayObject = M.getPlayerMovingDisplayObject( maxXplayer )
	local xDistanceMinMax = gfx.distance( minXplayerDisplayObject.x, 0, maxXplayerDisplayObject.x, 0 )
	-- Rule : if middle segment between xMin and xMax players is beyond a certain X distance,
	-- then we scroll by a certain factor
	local screenX, _y = gfx.coords_worldToScreen( minXplayerDisplayObject.x + xDistanceMinMax * .5, -1, "hero" )
	if screenX > calibrate.xThresholdToScrollCamera then
		gfx.translateCameraBy( calibrate.cameraIncrementX )
	else
		gfx.stopCameraTranslationImmediately()
	end
end


function M.checkBulletsHit()
	for i,weapon in ipairs( calibrate.weapons ) do
		if gfx.objectsByTag["hit_by_" .. weapon] and gfx.objectsByTag[weapon] then
			for k,vobjid in pairs(gfx.objectsByTag["hit_by_" .. weapon]) do
				local displayObj = gfx.displayObjects[vobjid]
				-- ignoring not visible objects (convenient for aliens in armors)
				if displayObj.visible then
					for kk,vvobjid in pairs(gfx.objectsByTag[weapon]) do
						local bullet = gfx.displayObjects[vvobjid]
						if not bullet.trash and M.objectsHit( displayObj, bullet ) then
							-- displayObj.visible = false
							if displayObj.callbackOnHit then
								local hitConfirmed = displayObj.callbackOnHit( bullet )
								if hitConfirmed then
									-- destroyed is a status var reserved for armors so we use trash to cleaup display objects
									bullet.trash = true
									bullet.visible = false
								end
							end
						end
					end
				end
			end
		end
	end
end

-- checks if an alien can enter an armor
function M.checkEmptyArmorsMatching()

	for n = 1,nbPlayers do
		local player = players[n]
		player.enterableArmor = nil
	end

	if gfx.objectsByTag["armor"] then
		for k,armorid in ipairs(gfx.objectsByTag["armor"]) do
			local armor = gfx.displayObjects[armorid]
			armor.enterable = false
			if armor.empty then
				for n = 1,nbPlayers do
					local player = players[n]
					if player.status == "naked" then
						local distance = gfx.distance( player.avatar.logic_x, player.avatar.logic_y, armor.logic_x, armor.logic_y )
						-- print( "distance between player " .. player.id .. "and armor " .. armor.id .. " : " .. distance )
						if distance < calibrate.maxDistanceToEnterArmor then
							armor.enterable = true
							player.enterableArmor = armor -- TODO : choose the closest one
						end
					end
				end
			end
		end
	end
end

-- checks if an alien can infiltrate a dead corpse
function M.checkDeadBodiesMatching()

	for n = 1,nbPlayers do
		local player = players[n]
		player.infiltrableBody = nil
	end

	if gfx.objectsByTag["soldier"] then
		for k,soldierid in ipairs(gfx.objectsByTag["soldier"]) do
			local enemy = gfx.displayObjects[soldierid]
			enemy.infiltrable = false
			if enemy.destroyed and not enemy.rotten and not enemy.parasited then
				for n = 1,nbPlayers do
					local player = players[n]
					if player.status == "naked" then
						local distance = gfx.distance( player.avatar.logic_x, player.avatar.logic_y, enemy.logic_x, enemy.logic_y )
						if distance < calibrate.maxDistanceToInfiltrateDeadBody then
							enemy.infiltrable = true
							player.infiltrableBody = enemy -- TODO : choose the closest one
						end
					end
				end
			end
		end
	end
end

-- checks if some zombies can start bonding
function M.checkZombiesMatching()

	for n = 1,nbPlayers do
		local player = players[n]
		-- player.infiltrableBody = nil
		if player.status == "zombie" and not player.avatar.vehicle.bonding then
			for n2 = 1,nbPlayers do
				if n2 ~= n then
					local player2 = players[n2]
					if player2.status == "zombie" and not player2.avatar.vehicle.bonding then
						local gameObj1, gameObj2 = M.getPlayerMovingDisplayObject(player), M.getPlayerMovingDisplayObject(player2)
						local distanceBetweenPlayers = gfx.distance( gameObj1.logic_x, gameObj1.logic_y, gameObj2.logic_x, gameObj2.logic_y )
						if distanceBetweenPlayers < calibrate.maxDistanceToBondWithOtherZombie then
							M.startBond( player, player2 )
						end
					end
				else
					-- ben non c'est moi
				end
			end
		end
	end

end

function M.spawnBullet( x, y, weapon, updateDX, updateDY, callbackOnHit )
	local id = "bullet" .. bulletCounter
	local picturePath = sprites.weapons[weapon]
	local o = gfx.addPicture( id, "bullets", picturePath, x, y )
	o.isBullet = true
	o.weapon = weapon
	o.updateDX = updateDX
	o.updateDY = updateDY
	o.callbackOnHit = callbackOnHit
	bulletCounter = bulletCounter + 1
	return o
end

function M.shootIfPossible( player, dt )
	local weapon = player.currentWeapon

	player.cooldown[weapon] = player.cooldown[weapon] - dt
	if player.cooldown[weapon] < 0 then
		-- shoot
		if player.avatar.vehicle then
			player.avatar.vehicle.heating = true
		end
		player.cooldown[weapon] = calibrate.cooldown_sec[weapon]
		local bullet = M.spawnBullet( player.aimX, player.aimY, weapon, player.shootDX, player.shootDY, function() print ("hit") end )
		bullet.emitterID = player.id
		gfx.tagDisplayObject( bullet.id, weapon )
	else
		-- no shoot, wait
	end

	-- if weapon == "knife" then
	-- elseif weapon == "gun" then

	-- else
	-- if weapon == "rocket" then
		-- player.cooldown.rocket = player.cooldown.rocket - dt
		-- if player.cooldown.rocket < 0 then
		-- 	-- shoot
		-- 	player.cooldown.rocket = calibrate.cooldown_sec.rocket
		-- 	local bullet = M.spawnBullet( player.aimX, player.aimY, "_coderart_rocket.png", player.shootDX, player.shootDY, function() print ("hit") end )
		-- 	gfx.tagDisplayObject( bullet.id, "rocket" )
		-- else
		-- 	-- no shoot, wait
		-- end
	-- elseif weapon == "machinegun" then
	-- elseif weapon == "laser" then
	-- end
end

function M.equipNextWeapon( player )
	local nextWeapon = allWeapons[player.currentWeapon]
	while not player.weapons[nextWeapon] do
		print( "I have no "..nextWeapon )
		nextWeapon = allWeapons[nextWeapon]
	end
	print( "I have a "..nextWeapon )
	player.currentWeapon = nextWeapon

end

function M.objectsHit( displayObj1, displayObj2 )
	local a, b = displayObj1, displayObj2
	return
		a.x + a.width > b.x and a.x < b.x + b.width
	and a.y + a.height > b.y and a.y < b.y + b.height
end

return M