-- Level generation

local M = {}

M.enemyIterator = 0

local stars = {
	"star_01_36.png",
	"star_01_13.png",
	"star_01_13.png",
	"star_01_13.png",
	"star_01_20.png",
	"star_01_20.png",
	"star_02_8.png",
	"star_02_8.png",
	"star_02_8.png",
	"star_02_16.png",
	"star_02_16.png",
}

function M.spawnEnemy( enemyType, y )
	M.enemyIterator = M.enemyIterator + 1
	local dispObjId = "enemy_" .. M.enemyIterator
	local o = gfx.addPicture( dispObjId, "hero", "_coderart_naked.png", W*.8, y )
	o.id = dispObjId
	o.callbackOnHit = function( hitter )
		if o.destroyed then
			return false
		end
		if hitter.isBullet then
			if gfx.tagged( o.id, "immune_to_bullets_from_" .. hitter.emitterID ) then
				return false
			end
			local dmg = calibrate.weaponDamageAmount[hitter.weapon]
			o.enemyHP = o.enemyHP - dmg
			if o.enemyHP < 0 then
				o.enemyHP = 0
				o.destroyed = true
				o.rottenComplete = 0
				o.timeBeforeRotten_sec = calibrate.timeBeforeRotten_sec
			end
			return true
		end
		return false
	end
	o.logic_dx = gfx.sizes[enemyType].hx
	o.logic_dy = gfx.sizes[enemyType].hy
	o.logic_x = o.x + o.logic_dx
	o.logic_y = o.y + o.logic_dy
	gfx.tagDisplayObject( dispObjId, "enemy" )
	gfx.tagDisplayObject( dispObjId, enemyType )
	gfx.tagDisplayObject( dispObjId, "hit_by_machinegun" )
	gfx.tagDisplayObject( dispObjId, "immune_to_bullets_from_" .. dispObjId )
	o.enemyHP = calibrate.maxEnemyHP[enemyType]
	return o
end

function M.newLevel()
	--gfx.addPicture( "bush", "env", "lvl_decor_bush.png", 100, 64 )
	

	

	for i = 1,1000 do
		local x, y, starindex = rand(0,4*W), rand(0, H), rand(1,#stars)
		gfx.addPicture( "star_" .. i, "far", stars[starindex], x, y )
	end


	gfx.addPicture( "newjupiter", "back", "newjupiter_1054.png", 200, 250 )


	local tie_fighter = gfx.addPicture( "enemy_1", "hero", "enemy01_200.png", 710, hH - 300 )
	gfx.tagDisplayObject( tie_fighter.id, "hit_by_rocket" )

	tie_fighter = gfx.addPicture( "enemy_2", "hero", "enemy02_220.png", 660, hH - 150 )
	gfx.tagDisplayObject( tie_fighter.id, "hit_by_rocket" )

	tie_fighter = gfx.addPicture( "enemy_3", "hero", "enemy01_200.png", 700, hH )
	gfx.tagDisplayObject( tie_fighter.id, "hit_by_rocket" )

	tie_fighter = gfx.addPicture( "enemy_4", "hero", "enemy01_200.png", 750, hH + 120 )
	gfx.tagDisplayObject( tie_fighter.id, "hit_by_rocket" )

end

return M