
if windowMode == "fullscreen" then

	-- get modes
	windowModes = love.window.getFullscreenModes()

	-- sort from largest to smallest
	table.sort( windowModes, function(a, b) return a.width*a.height > b.width*b.height end )

	-- Lists the modes
	print( "" )
	print( "================================" )
	print( "Modes supportés par cet écran :" )
	print( "================================" )
	for i,mode in ipairs(windowModes) do
		print( mode.width, mode.height )
	end

	-- Select the biggest mode accepted by this screen
	-- local mw,mh = windowModes[#windowModes].width, windowModes[#windowModes].height
	local mw,mh = windowModes[1].width, windowModes[1].height
	love.window.setMode(
		mw, mh,
		{
			fullscreen = true,
			-- fullscreentype = "desktop",
			-- display = 2,
			-- TODO: add support for multiple monitors
		}
	)


else
	-- not fullscreen or nil

	local windowW, windowH = windowW or 800, windowH or 600

	love.window.setMode(
		windowW, windowH
		-- ,{ -- flags
		-- 	fsaa = 6
		-- }
	)


end


-- Window Width, Window Height
-- NB: this is different from WH that are my artist's working coordinates (for instance 1024x768 or 1920x1080...)
windowW, windowH = love.window.getDimensions()
windowHalfW, windowHalfH = windowW*.5, windowH*.5

-- These ratios will help determine the letterbox model
local wRatio = W / windowW
local hRatio = H / windowH

-- Assuming wRatio >= hRatio...

-- Scale by touching left and right screen borders
local gameScreenWidth = windowW
local scaling = gameScreenWidth / W
local gameScreenHeight = H * scaling
local yOffset = math.ceil( windowHalfH - gameScreenHeight*.5 )
local xOffset = 0

if hRatio > wRatio then

	-- Scale by touching top and bottom screen borders
	gameScreenHeight = windowH
	scaling = gameScreenHeight / H
	gameScreenWidth = W * scaling
	xOffset = math.ceil( windowHalfW - gameScreenWidth*.5 )
	yOffset = 0

end

Wwidth, Wheight, Wflags = love.window.getMode( )
print( "windowFit",	"top", yOffset, "left", xOffset, "scale", scaling, "fsaa", Wflags.fsaa )

return {
	top = yOffset, left = xOffset, scale = scaling
}
